<template>
  <section class="form-page container">

    <a href="javascript:void(0)"
       class="form-page__back"
       @click="step === 2 ? goToStep(1) : $router.go(-1)"
    >
      <icon-arrow/>
      Вернуться назад
    </a>

    <ValidationObserver v-slot="{handleSubmit}"
                        v-if="step === 1">
      <form novalidate
            @submit.prevent="handleSubmit(onSubmit)"
            class="form-page-form">
        <h3 class="form-page-form__title">Ваш отзыв о платформе</h3>

        <p class="form-page-form__label">
          Нам важно знать ваше мнение о сервисе DЕЛИROOM.
        </p>

        <div class="form-page-form__wrapper">
          <ValidationProvider
            class="form-page-form__input-wrapper"
            v-slot="{errors}"
            name="name"
            rules="required">

            <form-input class="form-page-form__input"
                        v-model="fields.name"
                        :error="Boolean(errors.length)"
                        label="Имя"
                        name="name"
            />

          </ValidationProvider>

          <div class="form-page-form__input-wrapper">
            <form-input class="form-page-form__input"
                        v-model="fields.surname"
                        label="Фамилия"
            />
          </div>

          <ValidationProvider
            class="form-page-form__input-wrapper"
            v-slot="{errors, failedRules}"
            name="email"
            :customMessages="{ regex: 'Email введен неверно' }"
            :rules="{ regex: /^[-a-z0-9!#$%&'*+\/=?^_`{|}~]+(?:\.[-a-z0-9!#$%&'*+\/=?^_`{|}~]+)*@(?:[a-z0-9]([-a-z0-9]{0,61}[a-z0-9])?\.)*(?:aero|arpa|asia|biz|cat|com|coop|edu|gov|info|int|jobs|mil|mobi|museum|name|net|org|pro|tel|travel|[a-z][a-z])$/gmi, required: true }">

            <form-input class="form-page-form__input"
                        v-model="fields.email"
                        :error="Boolean(errors.length)"
                        :label="failedRules.regex ? failedRules.regex : 'Email'"
                        name="email"
            />

          </ValidationProvider>

          <ValidationProvider
            class="form-page-form__input-wrapper"
            v-slot="{errors, failedRules}"
            :customMessages="{ length: 'Телефон введен неверно' }"
            name="phone"
            rules="required|length:10">

            <form-input class="form-page-form__input"
                        type="tel"
                        v-model="fields.phone"
                        @input="onChangePhone"
                        :mask="true"
                        mask-type="phone-mask"
                        :error="Boolean(errors.length) || isPhoneInvalid"
                        :label="failedRules.length ? failedRules.length : isPhoneInvalid ? 'Телефон введен неверно' : 'Телефон'"
                        name="phone"
            />

          </ValidationProvider>

        </div>

        <ValidationProvider
          class="form-page-form__input-wrapper"
          v-slot="{errors}"
          name="review"
          rules="required">

          <base-textarea class="form-page-form__textarea"
                         v-model="fields.review"
                         :error="Boolean(errors.length)"
                         name="review"
                         label="Ваш отзыв"
          />

        </ValidationProvider>

        <div class="form-page-form__btn-row">
          <button type="submit"
                  class="form-page-form__btn button button--green">
            Отправить
          </button>

          <ValidationProvider
            v-slot="{errors}"
            name="rights"
            :rules="{ required: { allowFalse: false } }">

            <single-checkbox class="form-page-form__rights"
                             v-model="rights"
                             :error="Boolean(errors.length)"
                             name="rights">
              Я согласен(-на) с условиями <a href="/user_agreement.pdf" target="_blank">договора об использовании платформы</a>
              и <a href="/privacy_policy.pdf" target="_blank">политикой обработки персональных данных</a>.
            </single-checkbox>
          </ValidationProvider>
        </div>
        <recaptcha @error="onError" @success="onSuccess" />
      </form>
    </ValidationObserver>

    <section v-else class="form-page-success">
      <div class="form-page-success__icon">
        <icon-check />
      </div>

      <h3 class="form-page-success__title">Благодарим за&nbsp;ваш&nbsp;отзыв!</h3>

      <p class="form-page-success__label">
        Благодаря вашим отзывам и&nbsp;пожеланиям мы становимся лучше, поэтому нам крайне важна обратная связь с вами.
      </p>
    </section>


  </section>
</template>

<script>
  import {ValidationObserver, ValidationProvider} from 'vee-validate';

  import FormInput from '../components/FormInput';
  import IconArrow from '../components/icons/IconArrow';
  import Checkbox from '../components/Checkbox';
  import BaseTextarea from '../components/BaseTextarea';
  import IconCheck from '../components/icons/IconCheck';
  import SingleCheckbox from '../components/SingleCheckbox';

  import { getSeoBySlug, sendFeedback } from '../service/deliroom-service';

  export default {
    name: 'ReviewPage',
    components: {
      ValidationObserver,
      ValidationProvider,
      SingleCheckbox,
      IconCheck,
      BaseTextarea,
      Checkbox,
      IconArrow,
      FormInput
    },
    data: () => ({
      fields: {
        name: '',
        surname: '',
        email: '',
        phone: '',
        review: '',
      },

      captcha: '',
      isPhoneInvalid: false,
      rights: true,
      step: 1,
    }),

    asyncData: async () => ({
      meta: await getSeoBySlug('/reviews'),
    }),

    methods: {
      onChangePhone() {
        this.isPhoneInvalid = false;
      },

      goToStep(step) {
        window.scrollTo({top: 0, behavior: 'smooth'});
        this.step = step;
      },

      onError(error) {
        console.log('Error happened:', error)
      },

      async onSubmit() {
        try {
          this.captcha = await this.$recaptcha.getResponse();
          await this.$recaptcha.reset()
        } catch (error) {
          console.log('Login error:', error)
        }
      },

      async onSuccess() {
        const timer = setInterval(async () => {
          if (this.captcha) {
            clearInterval(timer);

            await this.sendForm();
          }
        }, 100);
      },

      async sendForm() {
        let { name, surname, email, phone, review:message } = this.fields;

        const feedbackResponse = await sendFeedback({
          name, surname, email, phone, message,
          captcha: this.captcha
        });

        if (feedbackResponse.errors) {
          this.isPhoneInvalid = feedbackResponse.errors.phone
            && feedbackResponse.errors.phone[0] === 'validation.phone';

          return;
        }

        this.resetForm();
        this.goToStep(2);

        this.$gtm.push({ event: 'reviews' });
      },

      resetForm() {
        Object.keys(this.fields).forEach((key) => this.fields[key] = '');
      }
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>
